#include <bits/stdc++.h>

#define X			first
#define Y			second
#define endl		'\n'

using namespace std;

void writeTest( int n, int m, vector< pair< int, int > > &g ) {
	cout << n << " " << m << endl;
	for( int i = 0; i < m; i ++ ) {
		cout << g[i].X << " " << g[i].Y << endl;
	}
}

int randNumber( int l, int r ) {
	int x = ( ( rand() << 16 ) + rand() ) % ( r - l + 1 ) + l;
	return x;
}

vector< int > randPermutation( int n ) {
	vector< int > v;
	for( int i = 1; i <= n; i ++ ) {
		v.push_back( i );
	}
	random_shuffle( v.begin(), v.end() );
	return v;
}

vector< pair< int, int > > randGraph( int n ) {
	vector< int > v = randPermutation( n );
	vector< pair< int, int > > g;
	for( int i = 1; i < v.size(); i ++ ) {
		int j = randNumber( 0, i-1 );
		g.push_back( make_pair( v[i], v[j] ) );
	}
	random_shuffle( g.begin(), g.end() );
	return g;
}

int main( int argc, char *argv[] ) {
	int test = atol( argv[1] );
	int minN = atol( argv[2] );
	int maxN = atol( argv[3] );
	
	srand( test + minN + maxN );

	int n = randNumber( minN, maxN );
	int m = n - 1;

	vector< pair< int, int > > g = randGraph( n );

	writeTest( n, m, g );
    return 0;
}
